 
/*

@autor: Moises Català García

App designed and programmed as part of the implementation from

'Projecte de Final de Grau en HTML5 per a dispositius mòbils' in Universitat Oberta de Catalunya 

APP Title: LanguagesWorld


This app is designed under the Model View Controller paradigm ""MVC""

uses Express JS Framework in order to deal with View and Controller parts of the code 
(Folders: 
 Cloud 		for Controllers 
 Cloud\view for Views)
 
 The model (Cloud Database) from the app and files are stored in Parse.com Cloud services

*/

//LanguagesWorld: Main starting app Point:


var express = require('express');
var expressLayouts = require('cloud/express-layouts');
var parseExpressCookieSession = require('parse-express-cookie-session');
var parseExpressHttpsRedirect = require('parse-express-https-redirect');

var app = express();

// Global app configuration section
app.set('views', 'cloud/views');  // Specify the folder to find templates
app.set('view engine', 'ejs');    // Set the template engine
app.use(expressLayouts);          // Use the layout engine for express
app.use(parseExpressHttpsRedirect());    // Automatically redirect non-secure urls to secure ones
app.use(express.bodyParser());    // Middleware for reading request body
app.use(express.methodOverride());
app.use(express.cookieParser('SECRET_SIGNING_KEY'));
app.use(parseExpressCookieSession({
  fetchUser: true,
  key: 'image.sess',
  cookie: {
    maxAge: 3600000 * 24 * 30
  }
}));

app.locals._ = require('underscore');

// User endpoints
app.use('/', require('cloud/user'));

// course endpoints
app.use('/course', require('cloud/course'));

// course endpoints
app.use('/noticeboard', require('cloud/noticeboard'));



app. get('/' , function(req, res){ 	 
	res.render('home');
});
 

// custom 404 page
app. use(function(req, res){
 res. type('text/plain' );
 res. status(404);
 res. send('404 - Page Not Found' );
});
// custom 500 page
app. use(function(err, req, res, next){
 console. error(err. stack);
 res. type('text/plain' );
 res. status(500);
 res. send('<b>500 - Server Error</b><br>' + err. stack );
});

// Attach the Express app to Cloud Code.
app.listen();
