// Provides endpoints for courses management

/*
Courses Management Controller

>Creates new courses
>Edits course
>Removes course
>Assigns students (user with student role) to course

Provides routing for /course pages

*/

//Sets all routes that user has to be logged in

var requireUser = require('cloud/require-user');

module.exports = function(){
	
	
		var express = require('express');
		var app = express();
   
  //Shows Fabrica de cursos Dashboard - 
	app.get('/', requireUser, function(req, res) {
	   res.render('course/homecourses');
	});  
	
	
	  //Shows course detail (not implemented!!!)
	app.get('/viewcourse', requireUser, function(req, res) {
		 
	   res.send('Funcionalitat no operativa' );
	});
	
	  //Shows courses students - 
	app.get('/mycourses', requireUser, function(req, res) {
		 
	   res.render('course/mycourses' );
	}); 
	
	//Returns courses list from student via JSON - 
	app.get('/getMyCourses', function(req, res) {
	     var StudentClass = Parse.Object.extend("User");
	   var CoursesClass = Parse.Object.extend("Course");	  
		var _field = req.param("field");
		var _valueEq = req.param("valueEq");
		
		//Gets student from system
 		var query = new Parse.Query(StudentClass);
		query.equalTo(_field, _valueEq);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				res.json({  
					   result : 'KO - No Student Found!' 
					   });
			  } else {	
					var currentStudent = objects[0]; 
					var quien = currentStudent.get("username");					
					var queryStudentCourses =  new Parse.Query(CoursesClass);
					queryStudentCourses.equalTo("students", currentStudent); 
					
					//Gets related courses from student
					queryStudentCourses.find({
					   success : function(courseslist) {
						   res.json({  
									   result : 'OK' ,
									   data : courseslist
						   });
					   },
					   error : function(error) {
						  alert("Error: " + error.code + " " + error.message);
					   }
					});
					
				}
			  
			}, function(error) {
			 alert("no Students found");
				res.json({  
					   result : 'KO - No Course Found. General Error' 
					   }); 	 
			}); 
	}); 
	
	  //Shows courses students - 
	app.get('/courseStudents', requireUser, function(req, res) {
		var _idCourse =  req.param("idCourse");  
		var _name =  req.param("name");
	   res.render('course/courseStudents', {idCourse : _idCourse,name : _name});
	});  
	
	//Shows form to where teacher can add students to current course
	app.get('/studentsAdd', requireUser, function(req, res) {
		var currentCourse = req.query.idCourse;
		var currentStudentGrade = req.query.studentGrade;
		var currentCourseName =req.query.nameCourse;
	   res.render('course/studentsAdd',{  idCourse :  currentCourse ,name :  currentCourseName ,studentGrade : currentStudentGrade });
	}); 
	
	//adds students to course
	app.post('/assignStudentCourse', function(req, res) {
		var _currentCourse = req.param("courseid");
		var currentStudentGrade = req.param("studentID");
		var Course = Parse.Object.extend("Course");
	    var Student = Parse.Object.extend("User");
		
		
 		var query = new Parse.Query(Course);
		query.equalTo("objectId", _currentCourse);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				res.render('course/coursemanager',{  flash :  "Curs no trobat!!!" }); 
			  } else {	
					var currentCourse = objects[0];
					//Finds student and adds relation
					var queryStudent = new Parse.Query(Student);
					queryStudent.equalTo("objectId", currentStudentGrade);
						queryStudent.find().then(function(objectsStudent) {
						   if (objectsStudent.length === 0) {
							 res.send("student not found"); 
							   res.render('course/coursemanager',{  flash :  "Estudiant no trobat!!!" }); 
						  } else {	
							//Add relation between course and student user
								var currentStudent = objectsStudent[0];
								var studentsRelation = currentCourse.relation("students");
								studentsRelation.add(currentStudent);
								currentCourse.save(); 
								
							    res.redirect('/course/editcourse?courseid='+_currentCourse); 
								  }
						  
						}, function(error) {
						 res.render('course/coursemanager',{  flash :  "Estudiant no trobat!!!" }); 
						}); 
					 
			  }
			  
			}, function(error) {
			res.render('course/coursemanager',{  flash :  "Curs no trobat!!!" }); 
			}); 
	   
	}); 
	
	
		//Returns course's students list via JSON - 
	app.get('/getCourseStudentsList', function(req, res) {
		
	   var StudentsClass = Parse.Object.extend("User");
	   var CourseClass = Parse.Object.extend("Course");	  
		var _field = req.param("field");
		var _valueEq = req.param("valueEq");
		
		//Gets course from system
 		var query = new Parse.Query(CourseClass);
		query.equalTo(_field, _valueEq);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				res.json({  
					   result : 'KO - No Course Found!' 
					   });
			  } else {	
					var currentCourse = objects[0]; 
					var currentStudentsRelation = currentCourse.relation("students"); 
					var queryStudents = currentStudentsRelation.query(); 
					//Gets related students from course
					queryStudents.find({
					   success : function(studentslist) {
						   res.json({  
									   result : 'OK' ,
									   data : studentslist
						   });
					   },
					   error : function(error) {
						  alert("Error: " + error.code + " " + error.message);
					   }
					});
					
				}
			  
			}, function(error) {
			 alert("no Students found");
				res.json({  
					   result : 'KO - No Course Found. General Error' 
					   }); 	 
			}); 
	});
	
	
		//Returns all students list via JSON - 
	app.get('/getStudents', function(req, res) {
	   var StudentsClass = Parse.Object.extend("User");
	   
		var _field = req.param("field");
		var _valueEq = req.param("valueEq");
 		var query = new Parse.Query(StudentsClass);
		query.equalTo(_field, _valueEq);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				//res.send("record not found"); 
				res.json({  
					   result : 'KO' 
					   });
			  } else {					
					 res.json({  
					   result : 'OK' ,
					   data : objects
					   });  // Send a JSON response with course's table
			  }
			  
			}, function(error) {
			 alert("no Students found");
				res.json({  
					   result : 'KO' 
					   }); 	 
			}); 
	});  
	
	
	
	//Returns courses list via JSON - 
	app.get('/getCourses', function(req, res) {
	   var Course = Parse.Object.extend("Course");		
 		var query = new Parse.Query(Course);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				//res.send("record not found"); 
				res.json({  
					   result : 'KO' 
					   });
			  } else {					
					 res.json({  
					   result : 'OK' ,
					   data : objects
					   });  // Send a JSON response with course's table
			  }
			  
			}, function(error) {
			 alert("no courses found");
				res.json({  
					   result : 'KO' 
					   }); 	 
			}); 
	});  
	
	
	
	
	//shows -new- course page
	 app.get('/newcourse', requireUser, function(req, res) {
	   res.render('course/coursemanager' , {
		   courseid : '-1',
		   name : '',
		   description : '',
		   studentGrade : '',
		   classroom : '',
		   dateBegin : '',
		   dateEnd : ''});
	}); 
	
		//shows -edit- course page
	 app.get('/editcourse', requireUser, function(req, res) {
		var _courseEdit = req.query.courseid;
		var Course = Parse.Object.extend("Course");		
		 
		 
		var query = new Parse.Query(Course);		
			query.equalTo("objectId", _courseEdit);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				//res.send("record not found"); 
			  } else {					
					var _name =  objects[0].get("name");
					var _description = objects[0].get("description");
					var _classroom = objects[0].get("classroom"); 
					var _studentGrade = objects[0].get("studentGrade"); 
					var aux=  new Date();
					aux = objects[0].get("dateBegin"); 
					var _dateBegin = aux.getDate()+"/"+aux.getMonth()+"/"+aux.getFullYear() ;
					aux = objects[0].get("dateEnd"); 
					var _dateEnd =  aux.getDate()+"/"+aux.getMonth()+"/"+aux.getFullYear() ;
				 
					res.render('course/coursemanager' , { 
					   courseid : _courseEdit,
					   name : _name,
					   description : _description,
					   classroom : _classroom,
					   studentGrade : _studentGrade,
					   dateBegin : _dateBegin,
					   dateEnd : _dateEnd,
				   });
			  }
			  
			}, function(error) {
			 alert("record not found");
				res.render('course/coursemanager' , {
						   courseid : '-1',
						   name : '',
						   description : '',
						   classroom : '',
						   studentGrade : '',
						   dateBegin : '',
						   dateEnd : '',});			 
			}); 
			 
		   
		   
	}); 
	 
	 //Deletes course from system
	  app.get('/deletecourse', function(req, res) {
		var _courseDelete = req.query.courseid;
		var Course = Parse.Object.extend("Course");		
		  
		 
		var query = new Parse.Query(Course);		
			query.equalTo("objectId", _courseDelete);
			
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				 alert("record not found>"+_courseDelete);
				 res.render('course/homecourses' , {  flash : "No s'ha pogut eliminar el curs. Es possible que ja s'hagi esborrat. Si encara apareix al llistat, contacta amb suport."  });
			  } else {		 
						  alert("destroying object");
						  var courseDelete = Parse.Object("Course");	
						  courseDelete = objects[0];
						  var coursepp = courseDelete.get("name");
						  alert("destroying object>>>>"+coursepp);
						  courseDelete.destroy({
							  success: function(courseDelete) {
								// The object was deleted from the Parse Cloud.
								alert("  object destroyed");
								 res.render('course/homecourses' , {  flash : "Curs eliminat satisfactoriament."  });
							  },
							  error: function(courseDelete, error) {
								// The delete failed.
								// error is a Parse.Error with an error code and message.
								alert("ERRORRRR destroying object>>>>"+error.message);
								 res.render('course/homecourses' , {  flash : "No s'ha pogut eliminar el curs. <br> Es possible que ja s'hagi esborrat. Si encara apareix al llistat, contacta amb suport"  });
							  }
							});
					
			  }
			  
			}, function(error) {
			 alert("record not found");
				res.render('course/homecourses' , {  flash : "No s'ha trobar el curs a eliminar. Si us plau, contacta amb suport."  });		 
			}); 
			 
		   
		   
	}); 
	 
	
	//adds (courseID = -1) or edits an existing course 
	 app.post('/newcourse', requireUser, function(req, res) {
		var name = req.body.name;
		var description = req.body.description; 
		var classroom = req.body.classroom; 
		var dateBegin = stringToDate(req.body.dateBegin,"dd/MM/yyyy","/");
		var dateEnd = stringToDate(req.body.dateEnd,"dd/MM/yyyy","/");
		var courseId = req.body.courseid;
		var studentGrade = req.body.studentGrade; 
		 
	 alert(courseId);
	 //Saves new course in database or updates an existing one
		if(courseId == '-1'){
			var courseAdd = new Parse.Object("Course");
			courseAdd.set('name', name);
			courseAdd.set('description', description);
			courseAdd.set('classroom', classroom);
			courseAdd.set('studentGrade', studentGrade);
			courseAdd.set('dateBegin', dateBegin); 
			courseAdd.set('dateEnd', dateEnd); 
			courseAdd.set('teacher',Parse.User.current())
			courseAdd.save().then(function(courseAdd) {			  
			    res.render('course/homecourses', { flash: "Curs afegit correctament" });
			}, function(error) {
			  // Show the error message and let the user try again	
				res.render('course/newcourse', { flash: error.message });
			});
		} else{
			 
			var Course = Parse.Object.extend("Course");		 
			var query = new Parse.Query(Course);		
				query.equalTo("objectId", courseId);
				query.find().then(function(objects) {
				   if (objects.length === 0) {
				  } else {					
						objects[0].set("name", name);
						objects[0].set("description", description);
						objects[0].set("classroom", classroom); 
						objects[0].set("studentGrade", studentGrade); 
						objects[0].set("dateBegin", dateBegin); 
						objects[0].set("dateEnd", dateEnd); 
						 
						alert('guardando nuevo curso...');
						objects[0].save().then(function(courseAdd) {			  
						   res.render('course/homecourses', { flash: "Curs actualitzat correctament" });
						}, function(error) {
						  // Show the error message and let the user try again	
							res.render('course/newcourse', { flash: error.message });
						});
				  }
				  
				}, function(error) {
				 alert("record not found");
					res.render('course/coursemanager' , {
							   courseid : '-1',
							   name : '',
							   description : '',
							   classroom : '',
							   studentGrade : '',
							   dateBegin : '',
							   dateEnd : '',});			 
				}); 
				 
		}
	});
	
	//Converts a string into date format with any kind of format
	function stringToDate(_date,_format,_delimiter)
		{
					var formatLowerCase=_format.toLowerCase();
					var formatItems=formatLowerCase.split(_delimiter);
					var dateItems=_date.split(_delimiter);
					var monthIndex=formatItems.indexOf("mm");
					var dayIndex=formatItems.indexOf("dd");
					var yearIndex=formatItems.indexOf("yyyy");
					var month=parseInt(dateItems[monthIndex]);
					month-=1;
					var formatedDate = new Date(dateItems[yearIndex],month,dateItems[dayIndex]);
					return formatedDate;
		}
	 
  return app;
}();


