// Provides endpoints for user signup and login

/*
notice board Controller

 

*/


//Sets all restricted routes that user has to be logged in

var requireUser = require('cloud/require-user');


module.exports = function(){
  var express = require('express');
  var app = express();

   
  //Shows active notices  - 
	app.get('/', requireUser, function(req, res) {
	   res.render('noticeboard/mainNoticeBoard');
	});  
	
	//Shows notice board editor - 
	app.get('/editorNoticeBoard', requireUser, function(req, res) {
	   res.render('noticeboard/editorNoticeBoard');
	}); 
	
	app.get('/getActiveNotices', requireUser, function(req, res) { 
			 	
		 var Notice  =   Parse.Object.extend("MainNoticeBoard");
		 
		var query = new Parse.Query(Notice);		
			//query.equalTo("objectId", _noticeid);  
			var today = new Date();
			query.greaterThanOrEqualTo("dateEnd",today ); 
			query.lessThanOrEqualTo("dateBegin",today );  
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				res.json({  
					   result : 'KO' 
					   });
			  } else {		
					res.json({  
					   result : 'OK' ,
					   data : objects
					   });
			  }
			  
			}, function(error) {
			 alert("error: record not found"); 
			res.json({  
					   result : 'KO' 
					   });
			});
	}); 
	
		//Shows notice board editor - 
	app.get('/editNotice', requireUser, function(req, res) {
		var _noticeid = req.param("noticeid");
		 if(_noticeid == -1 ){//new notice
			 res.render('noticeboard/editNotice',{  
				noticeid :  _noticeid,
				title : '',
				contentTxt : '', 
				dateBegin : '',
				dateEnd : ''	   });}
		else{
			 	
		 var Notice  =   Parse.Object.extend("MainNoticeBoard");
		 
		var query = new Parse.Query(Notice);		
			query.equalTo("objectId", _noticeid);
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				//res.send("record not found"); 
			  } else {					
					var _title =  objects[0].get("title");
					var _contentTxt = objects[0].get("contentTxt"); 
					  _contentTxt = _contentTxt.url().replace("http://", "https://s3.amazonaws.com/");
					var aux=  new Date();
					aux = objects[0].get("dateBegin"); 
					var _dateBegin = aux.getDate()+"/"+aux.getMonth()+"/"+aux.getFullYear() ;
					aux = objects[0].get("dateEnd"); 
					var _dateEnd =  aux.getDate()+"/"+aux.getMonth()+"/"+aux.getFullYear() ;
				 
					res.render('noticeboard/editNotice' , { 
					   noticeid : _noticeid,
					   title : _title,
					   contentTxt : _contentTxt, 
					   dateBegin : _dateBegin,
					   dateEnd : _dateEnd,
				   });
			  }
			  
			}, function(error) {
			 alert("record not found");
				res.render('noticeboard/editNotice',{  
				noticeid :  _noticeid,
				title : '',
				contentTxt : '', 
				dateBegin : '',
				dateEnd : ''	   });			 
			}); 
			
		}
	   
	}); 
	
	//adds (noticeid = -1) or edits an existing notice 
	 app.post('/editNotice', requireUser, function(req, res) {		
		var noticeid = req.body.noticeid;
		if (noticeid != -1 ){
			res.render('noticeboard/editorNoticeBoard', { flash: "Anunci modificat correctament" });
		}
		  else{
			  res.render('noticeboard/editorNoticeBoard', { flash: "Anunci afegit correctament" });
		  }
	});
 

	//Returns all notices list via JSON - 
	app.get('/getMainNotices', function(req, res) {
	   var NoticeBoardClass = Parse.Object.extend("MainNoticeBoard");
	   
		var _field = req.param("field");
		var _valueEq = req.param("valueEq");
 		var query = new Parse.Query(NoticeBoardClass); 
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				//res.send("record not found"); 
				res.json({  
					   result : 'KO' 
					   });
			  } else {					
					 res.json({  
					   result : 'OK' ,
					   data : objects
					   });  // Send a JSON response with notice's table
			  }
			  
			}, function(error) {
			 alert("no Notices found");
				res.json({  
					   result : 'KO' 
					   }); 	 
			}); 
	});  
		
 	 //Deletes course from system
	  app.get('/deleteMainNotice', function(req, res) {
		var _mainNoticeDelete = req.query.noticeid;
		var Course = Parse.Object.extend("MainNoticeBoard");		
		  
		 
		var query = new Parse.Query(Course);		
			query.equalTo("objectId", _mainNoticeDelete);
			
			query.find().then(function(objects) {
			   if (objects.length === 0) {
				 alert("record not found>"+_mainNoticeDelete);
				 res.render('noticeboard/editorNoticeBoard' , {  flash : "No s'ha pogut eliminar l'anunci. Es possible que ja s'hagi esborrat. Si encara apareix al llistat, contacta amb suport."  });
			  } else {		 
						  alert("destroying object");
						  var mainNoticeDelete = Parse.Object("MainNoticeBoard");	
						  mainNoticeDelete = objects[0];
						  var coursepp = mainNoticeDelete.get("title");
						  alert("destroying object>>>>"+coursepp);
						  mainNoticeDelete.destroy({
							  success: function(mainNoticeDelete) {
								// The object was deleted from the Parse Cloud.
								alert("object destroyed");
								 res.render('noticeboard/editorNoticeBoard' , {  flash : "Anunci eliminat satisfactoriament."  });
							  },
							  error: function(mainNoticeDelete, error) {
								// The delete failed.
								// error is a Parse.Error with an error code and message.
								alert("ERRORRRR destroying object>>>>"+error.message);
								 res.render('noticeboard/editorNoticeBoard' , {  flash : "No s'ha pogut eliminar l'anunci. <br> Es possible que ja s'hagi esborrat. Si encara apareix al llistat, contacta amb suport"  });
							  }
							});
					
			  }
			  
			}, function(error) {
			 alert("record not found");
				res.render('noticeboard/editorNoticeBoard' , {  flash : "No s'ha trobar el curs a eliminar. Si us plau, contacta amb suport."  });		 
			}); 
			 
		   
		   
	}); 
	
 //Converts a string into date format with any kind of format
	function stringToDate(_date,_format,_delimiter)
		{
					var formatLowerCase=_format.toLowerCase();
					var formatItems=formatLowerCase.split(_delimiter);
					var dateItems=_date.split(_delimiter);
					var monthIndex=formatItems.indexOf("mm");
					var dayIndex=formatItems.indexOf("dd");
					var yearIndex=formatItems.indexOf("yyyy");
					var month=parseInt(dateItems[monthIndex]);
					month-=1;
					var formatedDate = new Date(dateItems[yearIndex],month,dateItems[dayIndex]);
					return formatedDate;
		}
 
  return app;
}();


