// Provides endpoints for user signup and login

/*
User Management Controller

>Creates new users (Being administrative user)
>Edits current logged user
  

Provides routing for home page, wiki, notice board, and login
 

*/


//Sets all restricted routes that user has to be logged in

var requireUser = require('cloud/require-user');


module.exports = function(){
  var express = require('express');
  var app = express();

    // Retrieves current user details and returns it in JSON format
  app.get('/getuser', function(req, res) {
	  
	   res.json({  
	   name : Parse.User.current().get("name"),
		surname : Parse.User.current().get("surname"),
		email : Parse.User.current().get("email"),
		telephone : Parse.User.current().get("telephone"),
		city : Parse.User.current().get("city"),
		address : Parse.User.current().get("address"),
		myroles : Parse.User.current().get("myroles"),
		studentGrade : Parse.User.current().get("studentGrade"),
	   result : 'OK' 
	   });  // Send a JSON response 
  });
	
	  // updates current user details and returns it in JSON format
  app.post('/updateuser', requireUser, function(req, res) {
	   
		var password = req.body.password;
		
		var name = req.body.name;
		var surname = req.body.surname;
		var address = req.body.address;
		var telephone = req.body.telephone;
		var city = req.body.city;
		var studentGrade = req.body.studentGrade;

		var myroles = req.body.userrole;
		
		var rolesArray = [];
		if (typeof myroles === 'string'){
			rolesArray.push(myroles);
		}else
		{
			rolesArray = myroles;		
		}
	  var user = Parse.User.current();		
		user.set('password', password);
		user.set('name', name);
		user.set('surname', surname);
		user.set('address', address);
		user.set('telephone', telephone);
		user.set('city', city);
		user.set('studentGrade', studentGrade);
		user.set('myroles', rolesArray);
		
		user.save().then(function(user) {
		  res.redirect('/');
		}, function(error) {
		  // Show the error message and let the user try again	  
			res.render('user/edituser', { flash: error.message });
		});
  }); 
	
	
     // Renders the edit user page
  app.get('/edituser', requireUser, function(req, res) {
	  res.render('user/edituser'); 
  });  
  // Renders the signup page
  app.get('/signup', requireUser, function(req, res) {
    res.render('user/signup');
  });

  // Signs up a new user
  app.post('/signup', requireUser, function(req, res) {
		var username = req.body.email;
		var password = req.body.password;
		
		var name = req.body.name;
		var surname = req.body.surname;
		var address = req.body.address;
		var telephone = req.body.telephone;
		var city = req.body.city;
		var studentGrade = req.body.studentGrade;

		var myroles = req.body.userrole;
		
		var rolesArray = [];
		if (typeof myroles === 'string'){
			rolesArray.push(myroles);
		}else
		{
			rolesArray = myroles;		
		}
		
	 
		//Creates user object and saves in persistence
	 var user = new Parse.User();
		user.set('username', username);
		user.set('password', password);
		user.set('email', username);
		user.set('name', name);
		user.set('surname', surname);
		user.set('address', address);
		user.set('telephone', telephone);
		user.set('city', city);
		user.set('studentGrade', studentGrade);
		user.set('myroles', rolesArray);
		
		user.save().then(function(user) {
		  res.redirect('/');
		}, function(error) {
		  // Show the error message and let the user try again	  
			res.render('user/signin', { flash: error.message });
		});
		 
  });

  // Render the login page
  app.get('/login', function(req, res) {
    res.render('user/login');
  });

  // Logs in the user
  app.post('/login', function(req, res) {
    Parse.User.logIn(req.body.username, req.body.password).then(function(user) {
      res.redirect('/');
    }, function(error) {
      // Show the error message and let the user try again
	  alert(error.message);
      res.render('user/login', { flash: error.message });
    });
  });

  // Logs out the user
  app.get('/logout', requireUser, function(req, res) {
    Parse.User.logOut();
    res.redirect('/');
  });
  
  
  // Render the recover password page
  app.get('/forgotpassword', function(req, res) {
    res.render('user/forgotpassword');
  });

  
    // recovers user's password
  app.post('/forgotpassword', function(req, res) {
			Parse.User.requestPasswordReset(req.body.email, {
				  success: function() {
				  // Password reset request was sent successfully
					res.send( '<a href=\'/\'>Email enviat correctament amb les instruccions per a recuperar la contrasenya</a>');
				  },
				  error: function(error) {
					// Show the error message somewhere
					res.render('user/forgotpassword', { flash: error.message });
				  }
				});
  })
  return app;
}();


